# ------------------------------------------------------------
# Single component metropolis hastings
# for logistic regression example
# 
# 13 Sep 2007 Ioannis Ntzoufras 
#             Athens University of Economics and Business
# ------------------------------------------------------------
#
ex2.3.scrw.logregr<-function(y=wais$senility, x=wais$wais, prop.sd=c(1.75,0.2), iter=3500, beta0=c(0,0)){
Iterations<-iter 
mu.beta<-c(0,0); s.beta<-c(100,100)  
prop.s<-prop.sd
beta <- matrix(nrow=Iterations, ncol=2) 
acc.prob <- c(0,0) 
current.beta<-beta0
p<-2
for (t in 1:Iterations){  
	for (j in 1:p){
 			prop.beta<- current.beta   
 			prop.beta[j]<- rnorm( 1, current.beta[j], prop.s[j] )   
 			cur.eta <-current.beta[1]+current.beta[2]*x 
 			prop.eta<-prop.beta[1]   +prop.beta[2]   *x 
 			if(sum(prop.eta>700)>0) {print(t);menu(0)}
 			if(sum(cur.eta >700)>0) {print(t);menu(0)}
 			loga <-(sum(  y*prop.eta - log( 1+exp(prop.eta) ) ) 
  					 -sum(  y*cur.eta  - log( 1+exp(cur.eta ) ) )
  					 +sum(dnorm(prop.beta,   mu.beta,s.beta,log=TRUE))
  					 -sum(dnorm(current.beta,mu.beta,s.beta,log=TRUE)))
 			u<-runif(1)  
 			u<-log(u)  
 			if( u < loga ) { 
 					current.beta<-prop.beta	  
 					acc.prob[j] <- acc.prob[j]+1 
 					}    
	} 					
 	beta[t,]<-current.beta  
} 

print(acc.prob/Iterations)
return(beta)

}

beta3<-ex2.3.scrw.logregr(iter=55000, prop.sd=c(1.75, 0.20))


